---
title: Web Periodic Background Synchronization API
slug: Web/API/Web_Periodic_Background_Synchronization_API
tags:
  - API
  - Background
  - Landing
  - Offline
  - Overview
  - PWA
  - Service Workers
  - Sync
  - Web Periodic Background Synchronization API
  - periodic
---
<p>{{securecontext_header}}</p>

<div>{{draft}}{{DefaultAPISidebar("Periodic Background Sync")}}</div>

<p class="summary">The Web Periodic Background Synchronization API provides a way to register tasks to be run in a {{domxref('Service Worker API','service worker')}} at periodic intervals with network connectivity. These tasks are referred to as periodic background sync requests.</p>

<h2 id="Web_Periodic_Background_Synchronization_Concepts_and_Usage">Web Periodic Background Synchronization Concepts and Usage</h2>

<p>The Periodic Background Sync API allows web applications to alert their service worker to make any updates, at a periodic time interval. Uses may include fetching latest content whilst a device is connected to wifi, or allowing background updates to an application.</p>

<p>The minimum time interval is set when the API is invoked; however the user agent might also take into account other factors which affect when the service worker receives the event. For instance previous website engagement, or connection to a known network.</p>

<p>The {{domxref('PeriodicSyncManager')}} interface is available through {{domxref('ServiceWorkerRegistration.periodicSync')}}. A unique tag identifier is set to 'name' the sync event, which can then be listened for within the {{domxref('ServiceWorker')}} script. Once the event is received you can then run any functionality available, such as updating caches or fetching new resources.</p>

<p>As this API relies on service workers, functionality provided by this API is only available in a secure context.</p>

<div class="note">
<p>At the time of writing, the Web Periodic Background Synchronization API is only available through an installed <a href="/en-US/docs/Web/Progressive_web_apps">Progressive Web App</a></p>
</div>

<h2 id="Web_Periodic_Background_Synchronization_Interfaces">Web Periodic Background Synchronization Interfaces</h2>

<dl>
 <dt>{{domxref('PeriodicSyncManager')}}</dt>
 <dd>Registers tasks to be run in a service worker at periodic intervals with network connectivity. These tasks are referred to as periodic background sync requests.</dd>
 <dt>{{domxref('PeriodicSyncEvent')}}</dt>
 <dd>Represents a synchronization event, sent to the {{domxref('ServiceWorkerGlobalScope', 'global scope')}} of a {{domxref('ServiceWorker')}}. It provides a way to run tasks in the service worker with network connectivity.</dd>
</dl>

<h2 id="Service_Worker_Additions">Service Worker Additions</h2>

<p>The following additions to the {{domxref('Service Worker API')}} are specified in the Periodic Background Sync specification to provide an entry point for using Periodic Background Sync.</p>

<dl>
 <dt>{{domxref("ServiceWorkerRegistration.periodicSync")}} {{readonlyinline}}</dt>
 <dd>Returns a reference to the {{domxref("PeriodicSyncManager")}} interface for registering tasks to run at specific intervals.</dd>
 <dt>{{domxref("ServiceWorkerGlobalScope.onperiodicsync")}}</dt>
 <dd>An event handler fired whenever a {{Event("periodicsync")}} event occurs. This happens at timed intervals, that are specified when registering a {{domxref('PeriodicSyncManager')}}.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following examples show how to use the interface.</p>

<h3 id="Requesting_a_Periodic_Background_Sync">Requesting a Periodic Background Sync</h3>

<p>The following asynchronous function registers a periodic background sync at a minimum interval of one day from a browsing context:</p>

<pre class="brush: js notranslate">async function registerPeriodicNewsCheck() {
  const registration = await navigator.serviceWorker.ready;
  try {
    await registration.periodicSync.register('fetch-news', {
      minInterval: 24 * 60 * 60 * 1000,
    });
  } catch {
    console.log('Periodic Sync could not be registered!');
  }
}
</pre>

<h3 id="Verifying_a_Background_Periodic_Sync_by_Tag">Verifying a Background Periodic Sync by Tag</h3>

<p>This code checks to see if a Periodic Background Sync task with a given tag is registered.</p>

<pre class="brush: js notranslate">navigator.serviceWorker.ready.then(registration =&gt; {
  registration.periodicSync.getTags().then(tags =&gt; {
    if (tags.includes('get-latest-news'))
      skipDownloadingLatestNewsOnPageLoad();
  });
});
</pre>

<h3 id="Removing_a_Periodic_Background_Sync_Task">Removing a Periodic Background Sync Task</h3>

<p>The following code removes a Periodic Background Sync task to stop articles syncing in the background.</p>

<pre class="brush: js notranslate">navigator.serviceWorker.ready.then(registration =&gt; {
  registration.periodicSync.unregister('get-latest-news');
});
</pre>

<h3 id="Listening_for_a_Periodic_Background_Sync_within_a_Service_Worker">Listening for a Periodic Background Sync within a Service Worker</h3>

<p>The following example shows how to respond to a periodic sync event in the service worker.</p>

<pre class="brush: js notranslate">self.addEventListener('periodicsync', event =&gt; {
  if (event.tag == 'get-latest-news') {
    event.waitUntil(fetchAndCacheLatestNews());
  }
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Periodic Background Sync')}}</td>
   <td>{{Spec2('Periodic Background Sync')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PeriodicSyncManager")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://web.dev/periodic-background-sync/">An article on using Periodic Background Sync</a></li>
 <li><a href="https://webplatformapis.com/periodic_sync/periodicSync_improved.html">A Periodic Background Sync demo app</a></li>
</ul>
